#pragma once
#include "Framework.h"
#include "Vertex.h"
#include "Matrix.h"
#include "TransformTools.h"
#include "Camera.h"
#include "Model.h"
#include "MD2Loader.h"
#include <vector>

using namespace std;
using namespace TransformTools;

class Rasteriser : public Framework
{
public:	
	bool Initialise();
	void Update(const Bitmap& bitmap);
	void Render(const Bitmap& bitmap);
	void ClearViewport(const Bitmap& bitmap);

	void DrawSquare(HDC hDc, const vector<Vertex> verticies);
	void DrawShape(HDC hDc, const vector<Vertex> verticies);

	void DrawWireFrame(HDC hDc, Model& model);

private:
	vector<Model> _sceneModels;

	Matrix _currentPerspectiveMatrix;
	Matrix _currentViewMatrix;
	float  _currentAspectRatio;

	int _rotation;

};

